#include "bibli.h"

/*------------------Tracés de points et de lignes-----------*/

void putpixel(img* im,int i,int j,COLORS c){
  int w=im->width;
  im->colors[i*w+j]=c;
}

void trace_quadrant_est(img *im, pt p0, pt p1){
  //efficace si dx< dy
  assert(p1.color == p0.color);//même couleur
  float dx = p1.x-p0.x, dy = p1.y-p0.y;
  putpixel(im,(int) p0.x,(int) p0.y,p0.color);
  for (int i=1;i<dx;i++){
    putpixel(im,p0.x + i,
	     p0.y + floor(0.5 + dy * i / dx),
	     p0.color);
	     }
  putpixel(im,(int) p1.x,(int) p1.y,p1.color);
}


void trace_quadrant_sud(img *im, pt p0, pt p1){
  //efficace si dy > dy
  assert(p1.color == p0.color);//même couleur
  float dx = p1.x-p0.x, dy = p1.y-p0.y;
  putpixel(im,(int) p0.x,(int) p0.y,p0.color);
  for (int i=1;i<dy;i++){
    putpixel(im,
	     p0.x + floor(0.5 + dx * i / dy),
	     p0.y + i,
	     p0.color);
	     }
  putpixel(im,(int) p1.x,(int) p1.y,p1.color);
  }

void trace_segment(img *im, pt p0, pt p1){
   float dx = p1.x-p0.x, dy = p1.y-p0.y;
   if (dx == 0 && dy ==0)
     putpixel(im,(int) p0.x,(int) p0.y,p0.color);
   if (abs(dx)>abs(dy)){
     if (dx > 0)
       trace_quadrant_est(im,p0,p1);
     else
       trace_quadrant_est(im,p1,p0);
   }
   else{
      if (dy > 0)
       trace_quadrant_sud(im,p0,p1);
     else
       trace_quadrant_sud(im,p1,p0);
   }
}
